
use Compress::Zlib;

sub stars
{
  my $count=shift;
  my $i=0;
  my $line = "";
  for ($i;$i < $count ; $i++) {
    $line .= "*";
  }
  return $line;
}

################################################################################
# Get xml-files from tvmovie online
################################################################################
sub GetFiles {
	for ($days=0;$days < $days2download ;$days++) {
		doexit() if $please_exit;

		$now_string = DateCalc($heute,"+ $days tage",\$err,0);
		$now_string = UnixDate($now_string, "%Y%m%d");
		foreach $rfcid (keys %chan) {
			doexit() if $please_exit;

			# Kanal fr tvmovie konfiguriert ?
			next if $chan{$rfcid}[1] != "1";

			$filenamexml = "$now_string"."_$chan{$rfcid}[2].xml";
			$filenamexmltvm = "$filenamexml.tvm";
			$filenamexmlgz = "$filenamexml.gz";

			if (! -e "$downloadprefix$filenamexml") {
			print "tvmovie: downloading $baseurl$filenamexmltvm for $rfcid\n";
			my $dummy=GetContent("$baseurl$filenamexmltvm","$downloadprefix$filenamexmltvm");
			unscramble ("$downloadprefix$filenamexmltvm","$downloadprefix$filenamexmlgz");
			system("gunzip", "-f", "$downloadprefix$filenamexmlgz") == 0
				or warn "gunzip failed";
			}
		}
	}
}

################################################################################
# Get update xml-files from tvmovie online
################################################################################
sub GetUpdateFiles {
	$now_string = UnixDate($heute, "%Y%m%d");
	foreach $rfcid (keys %chan) {
		doexit() if $please_exit;

		# Kanal fr tvmovie konfiguriert ?
		next if $chan{$rfcid}[1] != "1";

		$filenamexml = "$now_string"."_$chan{$rfcid}[2].xml";
		$filenamexmltvm = "$filenamexml.tvm";
		$filenamexmlgz = "$filenamexml.gz";

		# Updatefiles werden IMMER neu geladen
		unlink "$updateprefix$filenamexmltvm"; unlink "$updateprefix$filenamexmlgz"; unlink "$updateprefix$filenamexml";

		if (! -e "$updateprefix$filenamexml") {
			print "tvmovie: downloading update file $aendurl$filenamexmltvm for $rfcid\n";
			my $dummy=GetContent("$aendurl$filenamexmltvm","$updateprefix$filenamexmltvm");
			unscramble ("$updateprefix$filenamexmltvm","$updateprefix$filenamexmlgz");
			system("gunzip", "-f", "$updateprefix$filenamexmlgz") == 0
				or warn "gunzip failed";
		}
	}
}

sub unscramble
{
    #Position .gz, Positon .tvm, Lnge
    #0x0000, 0x006A, 6
    #0x0006, 0x0064, 6
    #0x000C, 0x0070, 88
    #0x0064, 0x0320, 17
    #0x0075, 0x0011, 83
    #0x00C8, 0x012C, 100
    #0x012C, 0x0000, 17
    #0x013D, 0x0331, 183
    #0x01F4, 0x0258, 200
    #0x02BC, 0x0190, 200
    #0x0384, 0x00C8, 100
    #0x03E8, 0x03E8, Rest
    my $oldfilename = shift;
    my $filename = shift;
    print "tvmovie: descrambling $oldfilename to $filename\n";
    $size = -s $oldfilename;
	if ($size <= 1000) {
        rename $oldfilename, $filename;
        return;
    }

	open(OUT, "> $filename") || die "cannot write $filename: $!";
    open(IN,  "< $oldfilename") || warn "cannot read $oldfilename: $!";
    $outstring = "";
    seek (IN,0x006a,0) && read (IN,$outstring,  6) && print OUT $outstring;
    seek (IN,0x0064,0) && read (IN,$outstring,  6) && print OUT $outstring;
    seek (IN,0x0070,0) && read (IN,$outstring, 88) && print OUT $outstring;
    seek (IN,0x0320,0) && read (IN,$outstring, 17) && print OUT $outstring;
    seek (IN,0x0011,0) && read (IN,$outstring, 83) && print OUT $outstring;
    seek (IN,0x012c,0) && read (IN,$outstring,100) && print OUT $outstring;
    seek (IN,0x0000,0) && read (IN,$outstring, 17) && print OUT $outstring;
    seek (IN,0x0331,0) && read (IN,$outstring,183) && print OUT $outstring;
    seek (IN,0x0258,0) && read (IN,$outstring,200) && print OUT $outstring;
    seek (IN,0x0190,0) && read (IN,$outstring,200) && print OUT $outstring;
    seek (IN,0x00c8,0) && read (IN,$outstring,100) && print OUT $outstring;
    seek (IN,0x03e8,0) && read (IN,$outstring,10240000) && print OUT $outstring;
    close IN;
    close OUT;
    return;
exit;
}

sub ReadXMLFile
{
	$mode = shift;
	open(XMLFILE, "$xmlfile") || warn "cannot open $xmlfile: $!";
	my $event_id=$title=$subtitle=$datum=$zeit=$dauer= "";
	my $tmptext=$compare=$tmpwertung2=$origtitle=$kategory=$gentext="";
	my $genre=$land=$jahr=$fsk=$keywords=$tmptext=$text=$textt=$kritik="";
	my $tmpwertung=$wertung=$flags=$kurztext=$darsteller=$regie=$tmpdata= "";
	my $summary=$audio=$format=$rate=$infotext="";
	while(<XMLFILE>) {
		chomp;

		$_ = decode_entities($_);
		$_ =~ s/\&bull\;/\*/g;
		$_ =~ s/\&amp;bull;/\*/g;
		if ( m|\<Sendung\>|) {
			$state = "a";
			my $event_id=$title=$subtitle=$datum=$zeit=$dauer= "";
			my $tmptext=$compare=$tmpwertung2=$origtitle=$kategory=$gentext="";
			my $genre=$land=$jahr=$fsk=$keywords=$tmptext=$text=$textt=$kritik="";
			my $tmpwertung=$wertung=$flags=$kurztext=$darsteller=$regie=$tmpdata= "";
			my $summary=$audio=$format=$rate=$infotext="";
			next;
			}
		$event_id = $1					if $state eq "a" && m|<SendungID>(.*?)</SendungID>|;
		$title = $1					if $state eq "a" && m|<Titel>(.*?)</Titel>|;
		$datum = $1					if $state eq "a" && m|<Datum>(.*?)</Datum>|;	# 2003-10-30
		$zeit = $1					if $state eq "a" && m|<Zeit>(.*?)</Zeit>|;		# 20:15:00
		$dauer = $1	* 60				if $state eq "a" && m|<Dauer>(.*?)</Dauer>|;
		$audio = "Dolby"			if m|<dolby />|;
		$audio = "DolbyDigital"			if m|<dolbydigital />|;
		$audio = "Stereo"				if m|<stereo />|;
		$audio = "Surround"				if m|<surroundsound />|;
		$audio = "Zweikanal"			if m|<zweikanal />|;
		$audio .= " - O-Ton"			if m|<originaltitel />|;
		$format = "16:9"				if m|<breitband />|;
		$flags .= " [Premiere]"			if m|<tvpremiere />|;
		$flags .= " [SchwarzWei]"				if m|<sw />|;
		$flags .= " [Untertitel]"				if m|<untertitel />|;
		$flags .= " [Live]"				if m|<live />|;
		$flags .= " [Neu]"				if m|<neu />|;

#       <audiodescription /> == ??
#       <jubilaeum />	== runde Folgennummer
#       <letztefolge /> == Letze Folge
#       <wiederda /> == alte Schaetzchen



		$rate = "Tipp"			if m|<BewKategorieID>Tipp</BewKategorieID>|;
		$rate = "TopTipp"			if m|<BewKategorieID>TopTipp</BewKategorieID>|;
		$rate = "TagesTipp"		if m|<BewKategorieID>TagesTipp</BewKategorieID>|;
		$state = "e"					if $state eq "a" && m|</Sendung>|;

		# Beschreibung
		$state = "t1"					if $state eq "a" && m|<Text Kategorie="Inhalt">|;
		$gentext = $1					if $state eq "t1" && m|<Text>(.*)| && $gentext eq "";
		$state = "a"					if $state eq "t1" && m|^\s*</Text>|;

		# Info
		$state = "i1"					if $state eq "a" && m|<Text Kategorie="Info">|;
		$infotext = $1					if $state eq "i1" && m|<Text>(.*?)</Text>| && $infotext eq "";
		$state = "a"					if $state eq "i1" && m|^\s*</Text>|;

		# Thema (bei Dokus)
		$state = "th"					if $state eq "a" && m|<Text Kategorie="Thema">|;
		$textt .= $1 . "|"				if $state eq "th" && m|<Text>(.*?)</Text>|;
		$state = "a"					if $state eq "th" && m|^\s*</Text>|;

		# Genre
		if($state eq "a" && m|<!--reference to Film-->|) {
			$state = "gen";
			next;
			}

		if ($state eq "gen" && m|<(.*?)>|) {
			$type = $1;
			$state = "gen2";
			}

		$subtitle = $1					if $state eq "gen2" && m|<UnterTitel>(.*?)</UnterTitel>|;
		$genre = $1					if $state eq "gen2" && m|<GenreText>(.*?)</GenreText>|;
		$kategory = $1					if $state eq "gen2" && m|<RZPKategorieID>(.*?)</RZPKategorieID>|;
		$origtitle = $1					if $state eq "gen2" && m|<OriginalTitel>(.*?)</OriginalTitel>|;
		$land = $1					if $state eq "gen2" && m|<Land>(.*?)</Land>|;
		$jahr = $1					if $state eq "gen2" && m|<Jahr>(.*?)</Jahr>|;
		$fsk = $1					if $state eq "gen2" && m|<FSK>(.*?)</FSK>|;
		$state = "a"					if $state eq "gen2" && m|</$type>|;


		# Beschreibung berschreibt die vorherige Beschreibung
		$state = "t"					if $state eq "gen2" && m|<Text Kategorie="Inhalt">|;
		$text .= $1					if $state eq "t" && m|<Text>(.*)| && length($1) > length($gentext);
		$state = "gen2"					if $state eq "t" && m|^\s*</Text>|;

		# Kurzbeschreibung
		$state = "kb"					if $state eq "a"  && m|<Text Kategorie="Kurzbeschreibung">|;
		$kurztext = $1					if $state eq "kb" && m|<Text>(.*)</Text>|;
		$kurztext = ""					if $state eq "kb" && $kurztext =~ m/Lauftext/;
		$state = "a"					if $state eq "kb" && m|^\s*</Text>|;

		# Kurzkritik
		$state = "kk"					if $state eq "a"  && m|<Text Kategorie="Kurzkritik">|;
		$kritik = "Kurzkritik: $1"			if $state eq "kk" && m|<Text>(.*?)</Text>|;
		$state = "a"					if $state eq "kk" && m|^\s*</Text>|;

		# Bewertung
		$tmpwertung = stars($1)				if $state eq "gen2" && m|<Wertung>(.*?)</Wertung>|;
		if ($state eq "gen2" && m|<BewKategorieID>(.*?)</BewKategorieID>|) {
			$tmpwertung2 = $1;
			$tmpwertung = " $tmpwertung";
			$tmpwertung = ""			if $tmpwertung2 =~ m/Tipp/;	
			$wertung .= " / "			if $wertung ne "" && $tmpwertung2 ne "";
			$wertung .= "$tmpwertung2$tmpwertung";
			}

		# Darsteller
		$state = "ds"					if $state eq "gen2"  && m|<Mensch Kategorie="Schauspieler">|;
		$tmpdata = $1					if $state eq "ds" && m|<Name>(.*?)</Name>|;
		$tmpdata = "$1 $tmpdata"			if $state eq "ds" && m|<Vorname>(.*?)</Vorname>|;
		$darsteller .= ", $tmpdata ($1)"		if $state eq "ds" && m|<RollenName>(.*?)</RollenName>|;
		$state = "gen2"					if $state eq "ds" && m|^\s*</Mensch>|;

		# Regissr
		$state = "rg"					if $state eq "gen2"  && m|<Mensch Kategorie="Regisseur">|;
		$tmpdata = $1					if $state eq "rg" && m|<Name>(.*?)</Name>|;
		$regie = "$1 $tmpdata"				if $state eq "rg" && m|<Vorname>(.*?)</Vorname>|;
		$state = "gen2"					if $state eq "rg" && m|^\s*</Mensch>|;


		if ($state eq "e") { # Ende einer Sendung erreicht
			doexit() if $please_exit;

			$start = UnixDate("$datum $zeit", "%s");
			next if (UnixDate($heute, "%s") > $start+$dauer); # ist die Sendung schon vorbei ?
			$text =~ s/^(.*)\|$/$1/sig;
			$textt =~ s/^(.*)\|$/$1/sig;
			$darsteller =~ s/^, //sig;
			$type = "Serie" if $type eq "Folge";
			$genre =~ s/film$//; $genre =~ s/-?serie$//i; $genre =~ s/reihe$//i; $genre =~ s/show$//i; $genre =~ s/\/$//; $genre =~ s/-$//;
			$flags .= " [16:9]" if $format;
			$flags .= " [$audio]" if $audio;
			$flags .= " [$rate]" if $rate;
			$format = "4:3" unless $format;

			$text=$gentext if $text eq "";
			$text =~ s|</Text>||;

			$text     = pack "U0C*", unpack "C*", $text;
			$kurztext = pack "U0C*", unpack "C*", $kurztext;
			$textt    = pack "U0C*", unpack "C*", $textt;
			$infotext = pack "U0C*", unpack "C*", $infotext;
			$summary = "";
			$summary .= "$kurztext.|"		if $kurztext;
			$summary .= "Thema: $textt|" 		if $textt;
			$summary .= "$text" 			if $text;
			$summary .= "||Info: $infotext|"	if $infotext;

			makeEPGevent(	$event_id,$start,$dauer,$title,$subtitle,$id,$mode,
					$summary,$regie,$darsteller,$genre,$type,$country,
					$jahr,$audio,$format,$flags,$origtitle,$fsk,"",$rate,
					"",$kritik,$wertung);

			$id++;
			$state = "";
		} # if ($state eq "e")
	} # while(<XMLFILE>) {
	close (XMLFILE);
}



# Process info from XMLTV file / channels.conf 
sub ReadExternalEPG_tvmovie
{
	GetFiles();
	GetUpdateFiles() unless ($useupdate == 0);

	foreach $sender (keys(%chan)) {
		# Kanal fr tvmovie konfiguriert ?
		next if $chan{$sender}[1] != "1";
		doexit() if $please_exit;

		$id=1;
		$firstchannel=1;
		$found_orig_event=0;
		$orig_epg_id=0;
		$laststreamid = 0;
		our @events = "";
		# Find XML events
		$state="";

		my ($state,$event_id,$title,$subtitle,$datum,$zeit,$dauer,$tmptext,$text,$kritik,$tmpwertung,$wertung,$flags,$kurztext,$compare,$darsteller,$regie,$tmpdata) = "";
		for ($days=0;$days < $days2download ;$days++) {
			doexit() if $please_exit;

			$now_string = DateCalc($heute,"+ $days tage",\$err,0);
			$now_string = UnixDate($now_string, "%Y%m%d");
			$xmlfile = "$downloadprefix$now_string"."_"."$chan{$sender}[2].xml";
			print "tvmovie: reading $downloadprefix$now_string"."_"."$chan{$sender}[2].xml int memory\n";
			ReadXMLFile("original");
		} # for ($days=0;$days < $days2download ;$days++) {

		# EPG-Daten sortieren
		my($last) = 0;
		my(@temp);
		for(sort({ $a->{start} <=> $b->{start} } @events)) {
			doexit() if $please_exit;
			next if($last == $_->{start});
			push(@temp, $_); 
			$last = $_->{start};
		}
		$XML{$sender} = [ @temp ];

		next unless ($useupdate == 1);
		# XML enthlt jetzt alle Daten des Senders. jetzt Updatefiles parsen und Eintrge aktualisieren
		$now_string = UnixDate($heute, "%Y%m%d");
		$xmlfile = "$updateprefix$now_string"."_"."$chan{$sender}[2].xml";
		print "tvmovie: reading $updateprefix$now_string"."_"."$chan{$sender}[2].xml int memory\n";
		ReadXMLFile("update");

		# EPG-Daten sortieren, jetzt mit aktualisierte Sendungen
		my($last) = 0;
		my(@temp);
		for(sort({ $a->{start} <=> $b->{start} } @events)) {
			doexit() if $please_exit;
			push(@temp, $_); 
			$last = $_->{start};
		}
		$XML{$sender} = [ @temp ];
		# XML enthlt jetzt auch die nderungen, 
		# aber leider auch die durch updates ausgefallenen Sendungen ..


		# Updatesendung, die andere Sendungen ausblendet?
		for ($j=0; $j<$#{$XML{$sender}}-1;$j++) {
			if (@{$XML{$sender}}[$j]->{state} eq 2 &&				# aktualisierte Sendung
				@{$XML{$sender}}[$j+1]->{state} eq 1 &&				# Originalsendung
				@{$XML{$sender}}[$j+1]->{start}  >= @{$XML{$sender}}[$j]->{start} &&
				@{$XML{$sender}}[$j+1]->{stop}  <= @{$XML{$sender}}[$j]->{stop}) {
# wird auskommentiert, weil nichtmal der clickfinder das korrekt kann.
#
#				@{$XML{$sender}}[$j+1]->{state}        = 0; # gelschte Sendung
# print "@{$XML{$sender}}[$j+1]->{title} @{$XML{$sender}}[$j+1]->{event_id} @{$XML{$sender}}[$j+1]->{state} wird gelscht\n";
			}
		} # for 



	
	} # foreach $sender (keys(%chan))
} # sub ProcessEpg

return 1;
